      SUBROUTINE QUIKSRT(X,Y,Z,NPT)
***
***   SUBROUTINE TO SORT AN ARRAY OF POINTS ON ASCENDING X-VALUE
***   THE QUICKSORT ALGORITHM IS USED
***
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(NPT),Y(NPT),Z(NPT),LEFT(500),RIGHT(500)
      INTEGER LEFT,RIGHT,PT,R,RS
      LEFT(1)=1
      RIGHT(1)=NPT
      PT=1
5     L=LEFT(PT)
      LS=L
      R=RIGHT(PT)
      RS=R
      PT=PT-1
10    IF(R-L .LE. 0) GO TO 60
      PV=X(L)
      PVY=Y(L)
      PVZ=Z(L)
      IF(R-L .LT. 5) GO TO 20
      MED=(L+R)/2
      IF(PV .LT. X(R) .AND. PV .GT. X(MED)) GO TO 20
      IF(PV .LT. X(MED) .AND. PV .GT. X(R)) GO TO 20
      IF(X(R) .LT. PV  .AND. X(R) .GT. X(MED)) GO TO 15
      IF(X(R) .LT. X(MED) .AND. X(R) .GT. PV) GO TO 15
      PV=X(MED)
      PVY=Y(MED)
      PVZ=Z(MED)
      X(MED)=X(L)
      Y(MED)=Y(L)
      Z(MED)=Z(L)
      GO TO 20
15    PV=X(R)
      PVY=Y(R)
      PVZ=Z(R)
      X(R)=X(L)
      Y(R)=Y(L)
      Z(R)=Z(L)
20    IF(L .GE. R) GO TO 40
      IF(PV. GT. X(R)) GO TO 30
      R=R-1
      GO TO 20
25    IF(L .GE. R) GO TO 40
      IF(PV .LT. X(L)) GO TO 35
      L=L+1
      GO TO 25
30    X(L)=X(R)
      Y(L)=Y(R)
      Z(L)=Z(R)
      L=L+1
      GO TO 25
35    X(R)=X(L)
      Y(R)=Y(L)
      Z(R)=Z(L)
      R=R-1
      GO TO 20
40    X(L)=PV
      Y(L)=PVY
      Z(L)=PVZ
      IF(L-LS .LE. RS-L) GO TO 50
      IF(RS-L .LE. 1) GO TO 45
      LEFT(PT+1)=LS
      RIGHT(PT+1)=L-1
      L=L+1
      LS=L
      R=RS
      PT=PT+1
      GO TO 10
45    IF(L-LS .LE. 1) GO TO 60
      R=L-1
      RS=L
      L=LS
      GO TO 10
50    IF(L-LS .LE. 1) GO TO 55
      LEFT(PT+1)=L+1
      RIGHT(PT+1)=RS
      R=L-1
      RS=R
      L=LS
      PT=PT+1
      GO TO 10
55    IF(RS-L .LE. 1) GO TO 60
      L=L+1
      LS=L
      R=RS
      GO TO 10
60    IF(PT .LT. 1) RETURN
      GO TO 5
      END
